#!/usr/bin/env node
const { Command } = require('commander');
const inquirer = require('inquirer')
// const prompt = inquirer.createPromptModule();
const fs = require('fs')
const path = require('path')
const PromptConfiger = require('./config/SelectorOptionConfig');
const chalk = require('chalk');
const { off } = require('process');
const program = new Command();

program
    //.command('pyz-charts')
    .option('--v, --version', '版本号', )
    .option('-opt, -option [list]', '创建option类型[Bar,Pie...]', ['bar','pie'])
    .version(require('../package.json').version)
    .action((argv, options)=>{
        if(argv?.Option) {
            inquirer.prompt(PromptConfiger.Langua).then((answers)=>{
                // console.log(answers)
                const fileType = Object.values(answers)[0];
                // console.log(chalk.white.bgBlue.bold('你选择了语言：'), 
                // chalk.white.bgRed.bold(`${Object.keys(answers)[0]}`));

                inquirer.prompt(PromptConfiger.PyzChartsOptionSelector).then((ansoption)=>{
                    const chartsType = Object.values(ansoption)[0];
                    // console.log(chalk.white.bgBlue.bold(`你选择了自动创建的文件：${chartsType}`),
                    // chalk.white.bgRed.bold(`${Object.keys(answers)[0]}`, 
                    // chalk.white.bgRed.bold(`类型`)));
                    inquirer.prompt(PromptConfiger.vueFile).then((isVue)=>{
                            const vuePomit = isVue;

                            inquirer.prompt(PromptConfiger.fileName).then(async (filename)=>{
                                let Type = chartsType;
                                let fileName = Object.values(filename)[0];
                                fileName = fileName || `Default${Type}Option`;
                                let file = `${fileName}${fileType}`;
                                console.log(chalk.green.bold(`${file}加入文件队列`));
                                console.log(chalk.green.bold(`生成中...`));
                                let readFilePath = `${__dirname}/TempOptions/${Type}/${chartsType}${fileType}`;
                                let rootDir = path.join( path.resolve('node_modules'), '..');
                                let unkownRootDir = path.join( path.resolve('node_modules'), '..', 'src', 'static', 'ChartsOptions');
                                let isChartsOptionsDir = await fs.promises.stat(unkownRootDir).catch(e=>console.log(e))
                                if(!isChartsOptionsDir) {
                                    const srcDir =  path.join( path.resolve('node_modules'), '..', 'src');
                                    var isSrc = await fs.promises.stat(srcDir).catch(e=>console.log(e))
                                    if(!isSrc) await fs.promises.mkdir(srcDir);
                                    const staticPath = path.join(srcDir, 'static')
                                    var isStatic = await fs.promises.stat(staticPath).catch(e=>console.log(e))
                                    if(!isStatic) await fs.promises.mkdir(staticPath);
                                    isChartsOptionsDir = await fs.promises.stat(unkownRootDir).catch(e=>console.log(e));
                                    if(!isChartsOptionsDir) await fs.promises.mkdir(unkownRootDir);
                                }
                                let fileData = await fs.promises.readFile(readFilePath, 'utf-8');
                                let classFileData = renameOptionClass(fileData, Type, fileName);
                                await fs.promises.writeFile(path.join(unkownRootDir, file), classFileData, 'utf-8');
                                console.log(chalk.red.bold(`生成成功`));
                                console.log('位置在：', chalk.blue.bold(path.join(unkownRootDir, file)));
                                await createVueFile({
                                    vuePomit: vuePomit,
                                    chartsType: Type,
                                    optionName: fileName,

                                });
                            });
                    });
                });
            })
        }
      
    })
// program.showHelpAfterError('(请输入pyz-charts命令)')
    
program.parse(process.argv)

/**
 * 
 * @param {Boolean} bool 是否开启加载 
 * @return {void}
 */

function loadding(bool) {
    console.log(loadingText.loadingR[loadingText.index++%(loadingText.length-1)])
    setTimeout(()=>{
        if(bool) loadding(bool);
    },100)
}
/**
 * 
 * @param {String} classStr 数据
 * @param {String} chartsClassName 模板类名
 * @param {String} newClassName 新类名
 * @returns 
 */
function renameOptionClass(classStr, chartsClassName, newClassName) {
    return classStr.replace(new RegExp(chartsClassName), newClassName);
}
/**
 * 
 * @param {String} vueFileStr Vue文件流
 * @param {String} vueDefaultDefindName Vue模板名称
 * @param {String} newVueName Vue新名称
 * @returns 
 */
function renameVueComponent(vueFileStr, vueDefaultDefindName, newVueName) {
    return vueFileStr.replace(new RegExp(vueDefaultDefindName, 'g'), newVueName);
}
/**
 * 
 * @param {} obj 
 * @returns Promise<void>
 */
async function createVueFile(obj) {
    let vuePomit = obj?.vuePomit;
    let isCreateVue = Object.values(vuePomit)?.[0];
    if(isCreateVue) {
        let fileAs = `.${Object.keys(vuePomit)?.[0]}`; // 扩展名
        let chartsType = obj.chartsType;
        let optionName = obj.optionName;
        let componentsDir = path.join( path.resolve('node_modules'), '..', 'src', 'components');
        let readVueFilePath = `${__dirname}/TempOptions/${chartsType}/${chartsType}${fileAs}`;
        let isComponents = await fs.promises.stat(componentsDir).catch(e=>console.log(e))
        if(!isComponents) {
            const srcDir =  path.join( path.resolve('node_modules'), '..', 'src');
            var isSrc = await fs.promises.stat(srcDir).catch(e=>console.log(e))
            if(!isSrc) await fs.promises.mkdir(srcDir);
            isComponents = await fs.promises.stat(componentsDir).catch(e=>console.log(e));
            if(!isComponents) await fs.promises.mkdir(componentsDir);
        }
        let fileData = await fs.promises.readFile(readVueFilePath, 'utf-8');
        let classFileData = renameVueComponent(fileData, chartsType+'Option', optionName);
        await fs.promises.writeFile(path.join(componentsDir, optionName + fileAs), classFileData, 'utf-8');
        console.log('Vue组件在：', chalk.blue.bold(path.join(componentsDir, optionName + fileAs)));
    }
}

/**
 * 
 * @param {*} 
 * @return {void} 递归函数
 */

function loadingText () {}
loadingText.loadingR = ['/','-','\\'];
loadingText.loadingN = ['.', '..', '...', '....', '.....', '......']
loadingText.index = 0;